PatientCard/Models/DataModels/Patient.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace PatientCard.Models.DataModels
{

    [Table("patientcard.patient")]
    public class Patient : DataModelBase
    {

        [StringLength(12)]
        [Required]
        public string IIN { get; set; }

        [Required]
        public string Address { get; set; }

        [Required]
        [Phone]
        public string PhoneNumber { get; set; }

        public virtual List<VisitHistory> VisitHistory { get; } = new List<VisitHistory>();
    }
}

PatientCard/Models/DataModels/VisitHistory.cs
using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace PatientCard.Models.DataModels
{
    [Table("patientcard.visithistory")]
    public class VisitHistory : DataModelBase
    {

        [Required]
        public Enums.DoctorType DoctorType { get; set; }

        [Required]
        public string Diagnosis { get; set; }

        [Required]
        public string Complaints { get; set; }

        [Required]
        [DataType(DataType.Date)]
        public DateTime VisitDate { get; set; }

        [Required]
        public virtual Patient Patient { get; set; }
    }
}

PatientCard/Models/PatientsViewModel.cs
using System.ComponentModel.DataAnnotations;
using PatientCard.Models.DataModels;

namespace PatientCard.Models
{
    public class PatientViewModel: ViewModelBase
    {

        [StringLength(12, ErrorMessage = "Длина поля должна быть равна {2}", MinimumLength = 12)]
        [Required]

        [RegularExpression(@"^\d+", ErrorMessage = "ИИН должен содержать только цифры")]
        [Display(Name = "ИИН")]
        public string IIN { get; set; }

        [Required]
        [Display(Name = "Адрес")]
        public string Address { get; set; }

        [Required]
        [Phone]
        [Display(Name = "Номер телефона")]
        [RegularExpression(@"^[8]\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$", ErrorMessage = "Телефон должен быть в формате 8(###)###-####")]
        public string PhoneNumber { get; set; }

        public override void InitializeFromDb(DataModelBase source)
        {
            base.InitializeFromDb(source);
            var patient = (Patient) source;
            IIN = patient.IIN;
            Address = patient.Address;
            PhoneNumber = patient.PhoneNumber;
        }
    }
}

PatientCard/Models/VisitHistoryViewModel.cs
using System;
using System.ComponentModel.DataAnnotations;
using PatientCard.Models.DataModels;

namespace PatientCard.Models
{
    public class VisitHistoryViewModel : ViewModelBase
    {
        [Required]
        [Display(Name = "Специалист")]
        public Enums.DoctorType DoctorType { get; set; }

        [Display(Name = "Специалист")]
        public string DoctorTypeName => DoctorType.GetDisplayName();

        [Required]
        [Display(Name = "Диагноз")]
        public string Diagnosis { get; set; }

        [Required]
        [Display(Name = "Жалобы")]
        public string Complaints { get; set; }

        [Required]
        [Display(Name = "Дата посещения")]
        public string VisitDate { get; set; }

        [Required]
        public long PatientId { get; set; }

        public override void InitializeFromDb(DataModelBase source)
        {
            base.InitializeFromDb(source);
            var visit = (VisitHistory)source;
            DoctorType = visit.DoctorType;
            Diagnosis = visit.Diagnosis;
            Complaints = visit.Complaints;
            VisitDate = visit.VisitDate.ToString("yyyy-MM-dd");
            PatientId = visit.Patient.Id;
        }
    }
}

PatientCard/Controllers/PatientCardController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using PatientCard.Helpers;
using PatientCard.Models;
using PatientCard.Models.DataModels;

namespace PatientCard.Controllers
{
    public class PatientCardController : Controller
    {
        #region MainPage

        public ActionResult Index()
        {
            return View();
        }

        #endregion

        #region Patients

        public ActionResult Patient()
        {
            return View(new List<PatientViewModel>());
        }

        [HttpPost]
        public ActionResult PatientDetails(PatientViewModel model)
        {
            return PartialView(model);
        }

        #endregion

        #region VisitHistory

        public ActionResult VisitHistory(long patientId)
        {
            ViewBag.PatientId = patientId;
            return View(new List<VisitHistoryViewModel>());
        }


        [HttpPost]
        public ActionResult VisitInfo(VisitHistoryViewModel model)
        {
            return PartialView(model);
        }

        #endregion
    }
}

PatientCard/Controllers/PatientsController.cs
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Mvc;
using PatientCard.Helpers;
using PatientCard.Models;
using PatientCard.Models.DataModels;

namespace PatientCard.Controllers
{
    /// <summary>
    /// Информация о пациентах
    /// </summary>
    public class PatientsController : ApiController
    {
        /// <summary>
        /// Получить список всех пациентов
        /// </summary>
        /// <returns></returns>
        [System.Web.Http.HttpGet]
        public List<PatientViewModel> Patient()
        {
            var list = RepositoryHelper.Query<Patient>().ToList();
            var model = ViewModelBase.ToViewModel<Patient, PatientViewModel>(list);
            return model;
        }

        /// <summary>
        /// Получить данные пациента по идентификатору
        /// </summary>
        /// <param name="id">Идентификатор пациента</param>
        /// <returns></returns>
        [System.Web.Http.HttpGet]
        public PatientViewModel Patient(long id)
        {
            var patient = id > 0
                ? RepositoryHelper.Query<Patient>().First(w => w.Id == id)
                : new Patient();
            var model = new PatientViewModel();
            model.InitializeFromDb(patient);
            return model;
        }

        /// <summary>
        /// Удалить пациента по идентификатору
        /// </summary>
        /// <param name="id">Идентифкатор пациента</param>
        /// <returns></returns>
        [System.Web.Http.HttpDelete]
        public JsonResult DeletePatient(long id)
        {
            var item = RepositoryHelper.Query<Patient>().First(f => f.Id == id);
            var history = item.VisitHistory.ToList();
            history.ForEach(RepositoryHelper.Delete);
            RepositoryHelper.Delete(item);
            return new JsonResult { Data = Url.Content(@"\PatientCard\Patient")};
        }

        /// <summary>
        /// Добавить или изменить пациента
        /// </summary>
        /// <param name="patient">Модель с данными пациента</param>
        /// <returns></returns>
        [System.Web.Http.HttpPost]
        public JsonResult EditPatient(PatientViewModel patient)
        {
            if (patient.Id > 0)
            {
                var item = RepositoryHelper.Query<Patient>().First(f => f.Id == patient.Id);

                item.IIN = patient.IIN;
                item.Address = patient.Address;
                item.PhoneNumber = patient.PhoneNumber;
                item.FIO = patient.FIO;

                RepositoryHelper.Update(item);
            }
            else
            {
                var item = new Patient
                {
                    IIN = patient.IIN,
                    Address = patient.Address,
                    PhoneNumber = patient.PhoneNumber,
                    FIO = patient.FIO
                };

                RepositoryHelper.Insert(item);
            }

            return new JsonResult { Data = Url.Content(@"\PatientCard\Patient") };
        }
    }
}

PatientCard/Controllers/VisitHistoryController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Mvc;
using PatientCard.Helpers;
using PatientCard.Models;
using PatientCard.Models.DataModels;

namespace PatientCard.Controllers
{
    /// <summary>
    /// Информация о посещениях пациентов
    /// </summary>
    public class VisitHistoryController : ApiController
    {
        /// <summary>
        /// Получить данные истории посещений по пациенту
        /// </summary>
        /// <param name="patientId">Идентификатор пациента</param>
        /// <returns></returns>
        [System.Web.Http.HttpGet]
        public List<VisitHistoryViewModel> VisitHistory(long patientId)
        {
            //ViewBag.PatientId = patientId;
            var history = RepositoryHelper.Query<VisitHistory>()
                .Where(w => w.Patient != null && w.Patient.Id == patientId).ToList();
            var model = ViewModelBase.ToViewModel<VisitHistory, VisitHistoryViewModel>(history);

            return model;
        }

        /// <summary>
        /// Получить данные посещения по идентификатору
        /// </summary>
        /// <param name="id">Идентификатор посещения</param>
        /// <param name="patientId">Идентификатор пациента</param>
        /// <returns></returns>
        [System.Web.Http.HttpGet]
        public VisitHistoryViewModel VisitInfo(long id, long patientId)
        {
            var visit = id > 0
                ? RepositoryHelper.Query<VisitHistory>().First(w => w.Id == id)
                : new VisitHistory
                {
                    Patient = RepositoryHelper.Query<Patient>().First(f => f.Id == patientId)
                };
            var model = new VisitHistoryViewModel();
            model.InitializeFromDb(visit);
            return model;
        }

        /// <summary>
        /// Удалить данные о посещении по идентификатору
        /// </summary>
        /// <param name="id">Идентификатор посещения</param>
        /// <returns></returns>
        [System.Web.Http.HttpDelete]
        public ActionResult DeleteVisit(long id)
        {
            var item = RepositoryHelper.Query<VisitHistory>().First(f => f.Id == id);
            var patientId = item.Patient.Id;
            RepositoryHelper.Delete(item);
            return new JsonResult { Data = Url.Content(@"\PatientCard\VisitHistory?patientId=" + patientId) };
        }

        /// <summary>
        /// Добавить или изменить данные о посещении
        /// </summary>
        /// <param name="visit"></param>
        /// <returns></returns>
        [System.Web.Http.HttpPost]
        public ActionResult EditVisit(VisitHistoryViewModel visit)
        {
            if (visit.Id > 0)
            {
                var item = RepositoryHelper.Query<VisitHistory>().First(f => f.Id == visit.Id);
                item.DoctorType = visit.DoctorType;
                item.Complaints = visit.Complaints;
                item.Diagnosis = visit.Diagnosis;
                item.FIO = visit.FIO;
                item.VisitDate = DateTime.Parse(visit.VisitDate);

                RepositoryHelper.Update(item);
            }
            else
            {
                var item = new VisitHistory
                {
                    DoctorType = visit.DoctorType,
                    Complaints = visit.Complaints,
                    Diagnosis = visit.Diagnosis,
                    FIO = visit.FIO,
                    VisitDate = DateTime.Parse(visit.VisitDate),
                };
                var patient = RepositoryHelper.Query<Patient>().First(f => f.Id == visit.PatientId);
                item.Patient = patient;
                RepositoryHelper.Insert(item);
            }

            return new JsonResult { Data = Url.Content(@"\PatientCard\VisitHistory?patientId=" + visit.PatientId) };
        }

    }
}

PatientCard/Views/PatientCard/Index.cshtml
@{
    ViewBag.Title = "Карточка пациента";
}

<div class="jumbotron">
    <h1>Карточка пациента</h1>
    <p class="lead">Тестовое приложение</p>
</div>

PatientCard/Views/PatientCard/Patient.cshtml
@using PatientCard.Models
@model List<PatientViewModel>

@{
    ViewBag.Title = "Пациенты";
    var grid = new WebGrid(Model);
}

<!DOCTYPE html>

<html>
<head>
    <title>title</title>
    <script type="text/javascript" src="~/Scripts/tablesorter/jquery.tablesorter.combined.js"></script>
    <script type="text/javascript" src="~/Scripts/tablesorter/jquery.tablesorter.combined.min.js"></script>
    <link rel="stylesheet" href="/Content/theme.default.css">
</head>
<body>
    <div class="container">
        <h2>Список пациентов</h2>
        <div id="dialogContent"></div>
        <div class="col-md-12">
            <input type="text" class="form-control" id="search" placeholder="Введите текст для поиска" style="max-width: 100% !important">
            <hr>
            <a href="@Url.Action("PatientDetails", new {id = 0})" class="btn btn-default btn-edit" data-url="@Url.RouteUrl("DefaultApi",new { httproute = "", controller = "Patients", id = 0 })">Добавить</a>
        </div>
        <table Id="MainGrid" class="table table-striped table-hover tablesorter">
            <thead>
            <tr>
                <th>ИИН</th>
                <th>ФИО</th>
                <th>Адрес</th>
                <th>Телефон</th>
                <th data-sorter="false"></th>
                <th data-sorter="false"></th>
                <th data-sorter="false"></th>
            </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
</body>
</html>


@section scripts
{
    <script src="~/Scripts/js/patients.js"></script>
    <script type="text/javascript">
        $(function () {
            GetAllPatients();
        });

        function GetAllPatients() {
            $('#MainGrid').find('tbody').html('');
            $.ajax({
                url: '/api/Patients',
                type: 'GET',
                dataType: 'json',
                success: function (data) {
                    data.map(function (item) {
                        var row = "<tr>";
                        row += '<td class="filtering">' + item.IIN + "</td>";
                        row += '<td class="filtering">' + item.FIO + "</td>";
                        row += "<td>" + item.Address + "</td>";
                        row += "<td>" + item.PhoneNumber + "</td>";
                        row += "<td>" +
                            '@Html.ActionLink("История посещений", "VisitHistory", "PatientCard", new {patientId = "replaceValue"}, new {@class = "btn btn-default"})' +
                            "</td>";
                        row += "<td>" +
                            '@Html.ActionLink("Редактировать", "PatientDetails", new {id = "replaceValue"}, new {@class = "btn btn-default btn-edit", data_url = Url.RouteUrl("DefaultApi", new {httproute = "", controller = "Patients", id = "replaceValue"})})' +
                            "</td>";
                        row += "<td>" +
                            '@Html.RouteLink("Удалить", "DefaultApi", new {httproute = "", controller = "Patients", id = "replaceValue"}, new {@class = "btn btn-default btn-delete"})' +
                            "</td>";
                        row += "</tr>";
                        $('#MainGrid').find('tbody').append(row.replace(/replaceValue/g, item.Id));
                    });
                    $("#MainGrid").tablesorter();
                },
                error: function (x, y, z) {
                    alert(x + '\n' + y + '\n' + z);
                }
            });
        }
    </script>
}

PatientCard/Views/PatientCard/PatientDetails.cshtml
@model PatientCard.Models.PatientViewModel


<div id="showmodal" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button class="close" data-dismiss="modal" area-hidden="true">X</button>
                <h4>Пациент</h4>
            </div>
            <div class="modal-body">
                @using (Html.BeginRouteForm("DefaultApi", new { controller="Patients", httproute="true" }, FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
                {
                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    @Html.HiddenFor(m => m.Id)
                    <div class="form-group">
                        @Html.LabelFor(m => m.IIN, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextBoxFor(m => m.IIN, new { @class = "form-control" })
                            @Html.ValidationMessageFor(m => m.IIN, "", new { @class = "text-danger" })
                        </div>

                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.FIO, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextBoxFor(m => m.FIO, new { @class = "form-control" })
                            @Html.ValidationMessageFor(m => m.FIO, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.PhoneNumber, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextBoxFor(m => m.PhoneNumber, new { @class = "form-control", @type="phone" })
                            @Html.ValidationMessageFor(m => m.PhoneNumber, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.Address, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextBoxFor(m => m.Address, new { @class = "form-control" })
                            @Html.ValidationMessageFor(m => m.Address, "", new { @class = "text-danger" })
                        </div>
                    </div>
                        <div class="form-group">
                            <div class="col-md-offset-2 col-md-10">
                                <input type="submit" class="btn btn-default" value="Сохранить" />
                            </div>
                        </div>
                }
            </div>
        </div>
    </div>
</div>

<script src="~/Scripts/js/ModalHelper.js"></script>
<script src="~/Scripts/jquery.validate.js"></script>
<script src="~/Scripts/jquery.validate.min.js"></script>
<script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
<script src="~/Scripts/jquery.unobtrusive-ajax.min.js"></script>
<script >
    $("#PhoneNumber").keyup(function () {
        $(this).val($(this).val().replace(/^(\d{1})(\d{3})(\d{3})(\d{4})+$/, "$1($2)$3-$4"));
    })
</script>

PatientCard/Views/PatientCard/VisitHistory.cshtml
@using PatientCard.Models.DataModels
@model List<PatientCard.Models.VisitHistoryViewModel>

@{
    ViewBag.Title = "История посещений";
    var grid = new WebGrid(Model);
}

<!DOCTYPE html>

<html>
<head>
    <title>title</title>
    <script type="text/javascript" src="~/Scripts/tablesorter/jquery.tablesorter.combined.js"></script>
    <script type="text/javascript" src="~/Scripts/tablesorter/jquery.tablesorter.combined.min.js"></script>
    <link rel="stylesheet" href="/Content/theme.default.css">
</head>
<body>
    <div class="container">
        <br>
        <div class="col-md-12">
            <a href="@Url.Action("Patient")" class="btn btn-default">Назад</a>
        </div>
        <h2>История посещений</h2>
        <div id="dialogContent"></div>
        <div class="col-md-12">
            <a href="@Url.Action("VisitInfo", new {id = 0,patientId = ViewBag.PatientId})" class="btn btn-default btn-edit" data-url="@Url.RouteUrl("DefaultApi",new { httproute = "", controller = "VisitHistory", id = 0, patientId = ViewBag.PatientId})">Добавить</a>
        </div>
        <table Id="MainGrid" class="table table-striped table-hover tablesorter">
            <thead>
                <tr>
                    <th>Дата посещения</th>
                    <th>Специалист</th>
                    <th>ФИО Доктора</th>
                    <th>Диагноз</th>
                    <th>Жалобы</th>
                    <th data-sorter="false"></th>
                    <th data-sorter="false"></th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
</body>
</html>

@section scripts
{
    <script src="~/Scripts/js/patients.js"></script>
    <script type="text/javascript">
        GetPatientVisitHistory();

        function GetPatientVisitHistory() {
            $('#MainGrid').find('tbody').html('');
            $.ajax({
                url: '/api/VisitHistory?patientId=@ViewBag.PatientId',
                type: 'GET',
                dataType: 'json',
                success: function (data) {
                    data.map(function (item) {
                        var params = GetSortParameters(window.location.href);
                        switch (params["sortdir"]) {
                            case "ASC":
                                data = sortByKeyAsc(data, params["sort"]);
                                break;
                            case "DESC":
                                data = sortByKeyDesc(data, params["sort"]);
                                break;
                        }
                        var row = "<tr>";
                        row += '<td>' + new Date(item.VisitDate).toLocaleDateString() + "</td>";
                        row += '<td>' + item.DoctorTypeName + "</td>";
                        row += "<td>" + item.FIO + "</td>";
                        row += "<td>" + item.Diagnosis + "</td>";
                        row += "<td>" + item.Complaints + "</td>";
                        row += "<td>" +
                            ' @Html.ActionLink("Редактировать", "VisitInfo", new {id = "replaceValue", patientId = ViewBag.PatientId }, new {@class = "btn btn-default btn-edit", data_url = Url.RouteUrl("VisitHistoryDetails", new { httproute = "", controller = "VisitHistory", id = "replaceValue", patientId = ViewBag.PatientId}) })' +
                            "</td>";
                        row += "<td>" +
                            '@Html.RouteLink("Удалить", "DefaultApi", new { httproute = "", controller = "VisitHistory", id = "replaceValue" }, new { @class = "btn btn-default btn-delete" })' +
                            "</td>";
                        row += "</tr>";
                        $('#MainGrid').find('tbody').append(row.replace(/replaceValue/g, item.Id));
                    });
                    $("#MainGrid").tablesorter();
                },
                error: function (x, y, z) {
                    alert(x + '\n' + y + '\n' + z);
                }
            });
        }
    </script>
}

PatientCard/Views/PatientCard/VisitInfo.cshtml
@model PatientCard.Models.VisitHistoryViewModel

@{
    ViewBag.Title = "VisitInfo";
}


<div id="showmodal" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button class="close" data-dismiss="modal" area-hidden="true">X</button>
                <h4>История посещения</h4>
            </div>
            <div class="modal-body">
                @using (Html.BeginRouteForm("DefaultApi", new { controller = "VisitHistory", httproute = "true" }, FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
                {
                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    @Html.HiddenFor(m => m.Id)
                    @Html.HiddenFor(m => m.PatientId)
                    <div class="form-group">
                        @Html.LabelFor(m => m.VisitDate, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextBoxFor(m => m.VisitDate, new { @class = "form-control", min = new DateTime(1900, 01, 01).ToString("yyyy-MM-dd"), max = DateTime.Today.ToString("yyyy-MM-dd"), type = "date" })
                            @Html.ValidationMessageFor(m => m.VisitDate, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.DoctorType, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.EnumDropDownListFor(m => m.DoctorType, new { @class = "form-control" })
                            @Html.ValidationMessageFor(m => m.DoctorType, "", new { @class = "text-danger" })
                        </div>

                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.FIO, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextBoxFor(m => m.FIO, new { @class = "form-control" })
                            @Html.ValidationMessageFor(m => m.FIO, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.Diagnosis, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextAreaFor(m => m.Diagnosis, new { @class = "form-control", @type = "phone" })
                            @Html.ValidationMessageFor(m => m.Diagnosis, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(m => m.Complaints, new { @class = "col-md-2 control-label" })
                        <div class="col-md-10">
                            @Html.TextAreaFor(m => m.Complaints, new { @class = "form-control" })
                            @Html.ValidationMessageFor(m => m.Complaints, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input type="submit" class="btn btn-default" value="Сохранить" />
                        </div>
                    </div>
                }
            </div>
        </div>
    </div>
</div>

<script src="~/Scripts/js/ModalHelper.js"></script>
<script src="~/Scripts/jquery.validate.js"></script>
<script src="~/Scripts/jquery.validate.min.js"></script>
<script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
<script src="~/Scripts/jquery.unobtrusive-ajax.min.js"></script>
<script>
    $("#PhoneNumber").keyup(function () {
        $(this).val($(this).val().replace(/^(\d{1})(\d{3})(\d{3})(\d{4})+$/, "$1($2)$3-$4"));
    })
</script>